﻿Ext.require('App.Const.Finances');
Ext.define('App.Control.Kivii.Finances.InvoiceApply.Form', {
    extend: 'System.Control.EntityForm',
    xtype: 'App.Control.Kivii.Finances.InvoiceApply.Form',
    entityType: 'Kivii.Finances.Entities.InvoiceApply',
    layout: {
        type: 'responsivecolumn',
        states: {
            small: 600,
            large: 0
        }
    },
    autoscroll: true,
    viewModel: {
        data: {
            ButtonText: '申请',
            ButtonIcon: 'x-fa fa-plus',
            PaymentKvids: [],
            entity: {
                Metadata: {},
                Kvid: null,
                Type: null,
                Amount:0,
                OperateType: 'Debit',
                PayeeName: KiviiContext.CurrentMember.OrganizationName,
                Currency: 'CNY'
            }
        },
        formulas: {
            amountChineseBig: function(get) {
                let _amount = get('entity.Amount');
                return KiviiContext.Const.FinancesFunctionsMoneyToChineseBig(_amount);
            }
        }
    },
    dockedItems: [{
        xtype: 'toolbar',
        dock: 'top',
        items: ['->', {
            handler: '_onCreate',
            bind: {
                text: '{ButtonText}',
                iconCls: '{ButtonIcon}',
                disabled: '{!formIsValid}'
            }
        }]
    }],
    defaults: {
        labelWidth: 60,
        labelAlign: 'right',
        // margin: '0 10 10 10',
        readOnly: true,
        xtype: 'textfield'
    },
    items: [{
    	xtype: 'container',
        height: 200,
        layout: 'column',
        items: [{
            xtype: 'container',
            margin: '10 5 10 10',
            height: 180,
            columnWidth: 1 / 2,
            style: {
                border: '1px solid #C1C1C1'
            },
            layout: 'hbox',
            items: [{
                xtype: 'container',
                height: 180,
                width: 35,
                style: {
                    'border-right': '0.5px solid #C1C1C1'
                },
                html: '<div style="font-size:16px;margin-top:38px;margin-left:10px;width:10px;word-wrap:break-word;">&nbsp;&nbsp;购&nbsp;&nbsp;买&nbsp;&nbsp;方&nbsp;&nbsp;</div>'
            }, {
                xtype: 'container',
                height: 180,
                flex: 1,
                layout: 'column',
                defaults: {
                    xtype: 'textfield',
                    columnWidth: 1 / 2,
                    labelWidth: 65,
                    labelAlign: 'right',
                    margin: '0 10 10 10',
                    readOnly: true
                },
                items: [{
			        xtype: 'windowSelector',
			        columnWidth: 1,
			        margin: '10 10 5 10',
			        fieldLabel: '名&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;称',
			        editable: false,
			        readOnly: false,
			        allowBlank: false,
			        keyField: 'Kvid',
			        valueField: 'CompanyName',
			        value1Field: 'TaxNumber',
			        value2Field: 'CompanyAddress',
			        value3Field: 'Phone',
			        value4Field: 'BankName',
			        value5Field: 'BankAccount',
			        window: {
			            type: 'App.Control.Kivii.Finances.InvoiceTitle.Selector'
			        },
			        Type: 'Payee',
			        bind: {
			            key: '{entity.PayerKvid}',
			            value: '{entity.PayerName}',
			            value1: '{entity.PayerTaxNumber}',
			            value2: '{entity.PayerCompanyAddress}',
			            value3: '{entity.PayerPhone}',
			            value4: '{entity.PayerRegisteredBank}',
			            value5: '{entity.PayerBankAccount}'
			        }
			    }, {
                    fieldLabel: '纳&nbsp;&nbsp;税&nbsp;号',
                    margin: '0 10 5 10',
                    columnWidth: 1,
                    bind: '{entity.PayerTaxNumber}'
                }, {
                    fieldLabel: '地&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;址',
                    bind: '{entity.PayerCompanyAddress}'
                }, {
                    fieldLabel: '电&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;话',
                    bind: '{entity.PayerPhone}'
                }, {
                    fieldLabel: '开&nbsp;&nbsp;户&nbsp;行',
                    bind: '{entity.PayerRegisteredBank}'
                }, {
                    fieldLabel: '账&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;号',
                    bind: '{entity.PayerBankAccount}'
                }]
            }]
        }, {
            xtype: 'container',
            margin: '10 10 10 5',
            height: 180,
            columnWidth: 1 / 2,
            style: {
                border: '1px solid #C1C1C1'
            },
            layout: 'hbox',
            items: [{
                xtype: 'container',
                height: 180,
                width: 35,
                style: {
                    'border-right': '0.5px solid #C1C1C1'
                },
                html: '<div style="font-size:16px;margin-top:38px;margin-left:10px;width:10px;word-wrap:break-word;">&nbsp;&nbsp;销&nbsp;&nbsp;售&nbsp;&nbsp;方&nbsp;&nbsp;</div>'
            }, {
                xtype: 'container',
                height: 180,
                flex: 1,
                layout: 'column',
                defaults: {
                    xtype: 'textfield',
                    columnWidth: 1 / 2,
                    labelWidth: 65,
                    labelAlign: 'right',
                    margin: '0 10 10 10',
                    readOnly: true
                },
                items: [{
			        xtype: 'windowSelector',
			        columnWidth: 1,
			        margin: '10 10 5 10',
			        fieldLabel: '名&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;称',
			        editable: false,
			        readOnly: false,
			        allowBlank: false,
			        keyField: 'Kvid',
			        valueField: 'CompanyName',
			        value1Field: 'TaxNumber',
			        value2Field: 'CompanyAddress',
			        value3Field: 'Phone',
			        value4Field: 'BankName',
			        value5Field: 'BankAccount',
			        window: {
			            type: 'App.Control.Kivii.Finances.InvoiceTitle.Selector'
			        },
			        Type: 'Payee',
			        bind: {
			            key: '{entity.PayeeKvid}',
			            value: '{entity.PayeeName}',
			            value1: '{entity.PayeeTaxNumber}',
			            value2: '{entity.PayeeCompanyAddress}',
			            value3: '{entity.PayeePhone}',
			            value4: '{entity.PayeeRegisteredBank}',
			            value5: '{entity.PayeeBankAccount}'
			        }
			    }, {
                    fieldLabel: '纳&nbsp;&nbsp;税&nbsp;号',
                    margin: '0 10 5 10',
                    columnWidth: 1,
                    allowBlank: false,
                    bind: '{entity.PayeeTaxNumber}'
                }, {
                    fieldLabel: '地&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;址',
                    bind: '{entity.PayeeCompanyAddress}'
                }, {
                    fieldLabel: '电&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;话',
                    bind: '{entity.PayeePhone}'
                }, {
                    fieldLabel: '开&nbsp;&nbsp;户&nbsp;行',
                    bind: '{entity.PayeeRegisteredBank}'
                }, {
                    fieldLabel: '账&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;号',
                    bind: '{entity.PayeeBankAccount}'
                }]
            }]
        }]
    }, {
        xtype: 'numberfield',
        fieldLabel: '申请金额',
        emptyText: '请输入数字',
        hideTrigger: true,
        responsiveCls: 'big-50 small-100',
        minValue: 0,
        decimalPrecision: 2,
        // readOnly:false,
        bind: {
            readOnly: '{entity.OperateType==="Payment"}',
            value: '{entity.Amount}'
        },
        allowBlank: false
    },{
    	// xtype: 'radiogroup',
     //   fieldLabel: '发票类型',
     //   cls: 'x-check-group-alt',
     //   allowBlank: false,
     //   responsiveCls: 'big-50 small-100',
     //   // layout: 'anchor',
     //   name: 'Type',
     //   items: [
     //       {boxLabel: '专票', inputValue: 'VATS'},
     //       {boxLabel: '普票', inputValue: 'VAT'}//, checked: true}
     //   ],
     //   bind: {
     //       value: '{entity.Type}'
     //   }
    // }, {
        xtype: 'categoryField',
        fieldLabel: '发票类型',
        allowBlank: false,
        responsiveCls: 'big-50 small-100',
        internalCode: 'Type',
        readOnly: false,
        bind: {
            value: '{entity.Type}'
        }
    }, {
        xtype: 'textfield',
        responsiveCls: 'big-50 small-100',
        fieldLabel: '金额大写',
        bind: {
            value: '{amountChineseBig}'
        }
    }, {
        xtype: 'combo',
        responsiveCls: 'big-50 small-100',
        fieldLabel: '申请类型',
        queryMode: 'local',
        displayField: 'displayInfo',
        valueField: 'applyType',
        allowBlank: false,
        editable: false,
        filterPickList: true,
        readOnly: false,
        reference: 'applyType',
        store: {
            fields: ['displayInfo', 'applyType'],
            data: [{
                displayInfo: '到账申请',
                applyType: 'Payment'
            }, {
                displayInfo: '借票申请',
                applyType: 'Debit'
            }]
        },
        bind: {
            value: '{entity.OperateType}'
        }
    }, {
        fieldLabel: '摘&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;要',
        responsiveCls: 'big-100 small-100',
        readOnly: false,
        bind: {
            value: '{entity.Summary}',
        }
    }],
    listeners:{
    	afterrender:'_afterrender'
    },
    setOwner: function(_entity, _ctrl) {
        let _view = this;
        let _vm = _view.getViewModel();
        let _refs = _view.getReferences();
        _refs.applyType.setReadOnly(true);
        _vm.set('entity', _entity);
        _vm.set('ButtonText', _ctrl.text);
        _vm.set('ButtonIcon', _ctrl.iconCls);
        _vm.set('PaymentKvids',_entity.PaymentKvids);
        if(_entity.PayerName!==null){
        	Ext.Ajax.request({
                url: '/Restful/Kivii.Finances.Entities.InvoiceTitle/Query.json',
                params: {
                    CompanyName: _entity.PayerName
                },
                success: function(_response) {
                    let _rtns = Ext.decode(_response.responseText);
                    if (_rtns.Results.length <= 0) return Ext.toast('未找到对应抬头信息,请先添加!');
                    _vm.set('entity.PayerName', _rtns.Results[0].CompanyName);
                    _vm.set('entity.PayerKvid', _rtns.Results[0].Kvid);
                    _vm.set('entity.PayerTaxNumber', _rtns.Results[0].TaxNumber);
                    _vm.set('entity.PayerCompanyAddress', _rtns.Results[0].CompanyAddress);
                    _vm.set('entity.PayerPhone', _rtns.Results[0].Phone);
                    _vm.set('entity.PayerRegisteredBank', _rtns.Results[0].BankName);
                    _vm.set('entity.PayerBankAccount', _rtns.Results[0].BankAccount);
                },
                failure: function(_response) {
                    Ext.toast('请重试!');
                }
            });
        }
        // if (_entity.OperateType === "Payment") {
        //     let _form = Ext.create('App.Control.Kivii.Finances.InvoiceApply.Payment.Selector', {
        //         header: false
        //     });
        //     let _win = Ext.create('Ext.window.Window', {
        //         layout: 'fit',
        //         title: '请选择可开票到账',
        //         iconCls: _ctrl.iconCls,
        //         iconAlign: 'left',
        //         // header:false,
        //         autoScroll: true,
        //         width: 900,
        //         height: 500,
        //         modal: true,
        //         resizable: false,
        //         items: [_form]
        //     });
        //     _win.show();
        //     _form.on('entitySelected', function(_selectCtrl, _entities) {
        //         _win.close();
        //         let _paymentKvids = [];
        //         let _amount = 0;
        //         let _payerName = '';
        //         for (let _i = 0; _i < _entities.length; _i++) {
        //             let _select = _entities[_i];
        //             _payerName = _select.PayerName;
        //             _paymentKvids.push(_select.Kvid);
        //             _amount += parseFloat(parseFloat(_select.Amount - _select.AmountInvoice).toFixed(2));
        //         }
        //         _vm.set('entity.Amount', _amount);
        //         _vm.set('PaymentKvids', _paymentKvids);
        //         Ext.Ajax.request({
        //             url: '/Restful/Kivii.Finances.Entities.InvoiceTitle/Query.json',
        //             params: {
        //                 CompanyName: _payerName
        //             },
        //             success: function(_response) {
        //                 let _rtns = Ext.decode(_response.responseText);
        //                 if (_rtns.Results.length <= 0) return Ext.toast('未找到对应抬头信息,请先添加!');
        //                 _vm.set('entity.PayerName', _rtns.Results[0].CompanyName);
        //                 _vm.set('entity.PayerKvid', _rtns.Results[0].Kvid);
        //                 _vm.set('entity.PayerTaxNumber', _rtns.Results[0].TaxNumber);
        //                 _vm.set('entity.PayerCompanyAddress', _rtns.Results[0].CompanyAddress);
        //                 _vm.set('entity.PayerPhone', _rtns.Results[0].Phone);
        //                 _vm.set('entity.PayerRegisteredBank', _rtns.Results[0].BankName);
        //                 _vm.set('entity.PayerBankAccount', _rtns.Results[0].BankAccount);
        //             },
        //             failure: function(_response) {
        //                 Ext.toast('请重试!');
        //             }
        //         });

        //     });
        // }
    },
    controller: {
    	_afterrender:function(_ctrl,_eOpts){
    		let _controller = this;
            let _view = _controller.getView();
            let _vm = _controller.getViewModel();
            let _entity=_vm.data.entity;
            Ext.Ajax.request({
                url: '/Restful/Kivii.Finances.Entities.InvoiceTitle/Query.json',
                params: {
                    CompanyName: _entity.PayeeName
                },
                success: function(_response) {
                    let _rtns = Ext.decode(_response.responseText);
                    if (_rtns.Results.length <= 0) return Ext.toast('未找到对应抬头信息,请先添加!');
                    _vm.set('entity.PayeeName', _rtns.Results[0].CompanyName);
                    _vm.set('entity.PayeeKvid', _rtns.Results[0].Kvid);
                    _vm.set('entity.PayeeTaxNumber', _rtns.Results[0].TaxNumber);
                    _vm.set('entity.PayeeCompanyAddress', _rtns.Results[0].CompanyAddress);
                    _vm.set('entity.PayeePhone', _rtns.Results[0].Phone);
                    _vm.set('entity.PayeeRegisteredBank', _rtns.Results[0].BankName);
                    _vm.set('entity.PayeeBankAccount', _rtns.Results[0].BankAccount);
                },
                failure: function(_response) {
                    Ext.toast('请重试!');
                }
            });
    	},
        _onCreate: function(_ctrl) {
            let _controller = this;
            let _view = _controller.getView();
            let _vm = _controller.getViewModel();
            _ctrl.setDisabled(true);
            Ext.Ajax.request({
                url: '/Restful/'+_view.entityType+'/Apply.json',
                jsonData: {
                    Item: _vm.data.entity,
                    PaymentKvids: _vm.data.PaymentKvids
                },
                success: function(_response) {
                    let _rtns = Ext.decode(_response.responseText);
                    Ext.toast('申请成功！');
                    _ctrl.setDisabled(false);
                    _view.fireEvent('entityCreated', _controller, _rtns.Results[0]);
                },
                failure: function(_response) {_ctrl.setDisabled(false);}
            });
        }
    }
});